from dataclasses import dataclass

from . import DictCFG
from .manager import ConfigManager


@dataclass
class Translation(DictCFG, ConfigManager):
    born_1: str = "您尚未配置管理员，请在bot启动成功后私聊bot发送任意消息，bot会自动将您注册为管理员。"
    born_2: str = "✅初始化成功，您已被确定成管理员，已将您的身份写入到配置文件~"
    born_3: str = "您的UID为"
    born_4: str = "✅已初始化管理员"
    born_5: str = "群组ID: "
    b_ok = "👌完成设置"
    b_ok2 = "👌完成选择"
    b_reverse: str = "🪞选项翻转"
    b_nyd: str = "御三家(N-Y-D)"
    b_cancel: str = "👋点错了，给我取消"
    b_cancel2: str = "✅测试任务已取消"
    b_alive: str = "🩺节点存活率"
    b_okpage: str = "🔒完成本页选择"
    b_all: str = "♾️全测"
    b_origin: str = "🪵订阅原序"
    b_rhttp: str = "⬇️HTTP降序"
    b_http: str = "⬆️HTTP升序"
    b_aspeed: str = "⬆️平均速度升序"
    b_arspeed: str = "⬇️平均速度降序"
    b_mspeed: str = "⬆️最大速度升序"
    b_mrspeed: str = "⬇️最大速度降序"
    b_close: str = "❌关闭页面"
    b_back: str = "⬆️返回上一层"
    b_del_conf: str = "删除配置"
    b_edit_conf: str = "修改配置"
    b_add_conf: str = "新增配置"
    bot_version: str = "Bot版本"
    build_time: str = "编译时间"
    bye: str = "再见~"
    cache_not_found: str = "❌缓存资源未找到，任务无法生成。"
    commit: str = "提交哈希"
    colon: str = ":"
    error: str = "❌发生错误:"
    error_2: str = "⚠️生成图片失败,可能原因: 节点过多/网络不稳定"
    error_3: str = "❌UID需要是全数字，授权失败。"
    error_4: str = "❌节点数量为空，请检查你的过滤器或者订阅格式是否正确。"
    error_5: str = "❌此bot-token无效"
    error_6: str = "❌错误的Botid"
    error_7: str = "⚠️Bot无法找到您的测试数据，请先测试一次哦~"
    help_title: str = "节点测试BOT，可用指令如下："
    help_tourist: str = ""
    help_user: str = ""
    help_admin: str = ""
    help_other: str = ""
    help_tail: str = "如有使用问题请与Bot管理员联系"
    is_not_admin: str = "❌您不是bot的管理员，无法操作~"
    is_not_user: str = "❌您没有用户权限，无法使用~"
    mem: str = "运行内存"
    ms_type_err: str = "SlaveType must be MiaoSpeed. Please check your SlaveRequest Object."
    ms_type_err2: str = "MiapSpeed.ssl_type value is invalid."
    parse_url_err: str = "❌无法从消息的参数中获取到订阅链接"
    parse_task_name: str = "❌无法获得任务ID，重新发起测试吧~"
    page1: str = "⬅️上一页"
    page2: str = "下一页➡️"
    pyv: str = "Python版本"
    query_not_found: str = "❌按钮资源已回收~"
    reboot: str = "正在重启bot..."
    reboot2: str = "️开始重启(大约等待五秒)..."
    regex_err: str = "正则匹配错误，请检查正则表达式"
    reload_ok: str = "✅配置重载成功~"
    reload_err: str = "❌配置重载失败"
    submit: str = "⏳任务提交成功，正在处理中......"
    submit2: str = "❌任务提交失败，尝试检查指令上的参数是否正确"
    slave_select: str = "请选择测试后端:\n"
    slave_not_found: str = "❌您没有配置任何后端，无法发起测试任务~"
    sort_select: str = "请选择排序方式: \n"
    script_select: str = "请选择要测试的脚本名称: \n"
    selector_timeout_1: str = "SlaveSelector获取超时"
    selector_timeout_2: str = "SortSelector获取超时"
    selected: str = "已完成本页提交"
    selected_script: str = "🧵当前已选择的测试脚本: \n\n"
    script_ok: str = "⏳正在生成测试任务......"
    subget_err: str = "❌获取订阅失败，出错域名:"
    subget_err2: str = "❌节点数量超出限制，已取消测试"
    sysn: str = "系统名称"
    sysv: str = "系统版本"
    syst: str = "系统时间"
    username: str = "用户名"
    uid: str = "UID"
    usage_grant: str = ("使用方法1: /grant 或 /ungrant <UID> <UID2> <UID3> ... <UID99999>\n"
                        "使用方法2: /grant 或 /ungrant <回复一个目标>")
    progress_1: str = "⏳速度测试进行中..."
    progress_2: str = "⏳拓扑分析测试进行中..."
    progress_3: str = "⏳连通性测试进行中..."
    progress_4: str = "⚙️后端:"
    progress_5: str = "🎉队列中的任务数量为:"
    progress_6: str = "当前进度:"
    task_stop_1: str = "🛑中止测试"
    tr_ok = "Translation loaded: "
    ws_conn_err: str = "❌无法找到对应的WebSocket连接"
    ws_conn_err2: str = "❌后端连接失败，远程计算机拒绝网络连接"
    ws_conn_err3: str = "测试结束已断开连接: 主端 --X--> *:"
    ws_conn_err4: str = "连接超时: 主端 --X--> *:"
    ws_conn_err5: str = "❌测速任务已取消"
    ws_conn_err6: str = "❌发生错误: WebSocket连接已断开"
    ws_info: str = "▸ "
    ws_info2: str = "▸ "
    ws_info3: str = "✅存活后端 "
    ws_info4: str = "❌离线后端 "
    ws_info5: str = "的缓存结果"
    ws_info6: str = "您可以在"
    ws_info7: str = "秒后更新信息"
    ws_info8: str = "❌其他用户正在检查后端情况，请等待锁释放~"
    ws_info9: str = "🔍正在检查后端情况..."
    ws_info10: str = "个"
    ws_info11: str = "✅已发送测试请求，正在等待回应~"
    ws_info12: str = "使用了不安全的websocket连接路径： "
    ws_info13: str = "❌无效的测试结果数据，任务已被丢弃"
    time_used: str = "⏱️总共耗时"
    ws_conn_msg: str = "\n🎗️提示: 更少的节点数量将获得更高的测试优先级"
    grant_1: str = "以下UID已被加入到授权列表: \n"
    grant_2: str = "以下UID已被移出授权列表: \n"
    bot_token_err: str = "您没有设置bot-token，考虑在config.yaml加入以下配置: \nbot: \n bot-token: 12345:abcdefg"
    task_name: str = "\n🎉任务名称: "
    items: str = "\n🧵测试项: \n\n"
    license_err: str = "激活码读取错误，请检查激活码是否输入正确"
    license_err2: str = "此激活码无法适用于您的bot-token"
    usage_license: str = "使用方法: `/license <Bot的UID>`"
    license_1: str = "激活状态:"
    license_2: str = "激活目标:"
    license_3: str = "生成时间:"
    license_4: str = "失效时间:"
    b_test: str = "📺 连通性测试"
    b_topo: str = "🔗 拓扑测试"
    b_speed: str = "🚗 速度测试"
    b_full: str = "🚗 全量测试"
    b_ping: str = "📶 延迟测试"
    b_udptype: str = "📶 UDP类型"
    invite_1: str = "🎯您好,"
    invite_2: str = "为您创建了一个测试任务，请选择测试的类型:"
    invite_3: str = "输入 /help 查看使用说明"
    invite_4: str = "未找到测试类型，取消验证。"
    invite_5: str = "❌ID验证失败，请不要乱用别人的测试哦！"
    invite_6: str = "✅身份验证成功"
    invite_7: str = "🚗任务项:"
    invite_8: str = "**接下来请在"
    invite_9: str = "s内发送Clash配置格式的订阅链接** <过滤器> \n否则任务取消"
    invite_10: str = "⏳正在等待上传订阅链接~"
    invite_11: str = "❌此任务队列已被销毁，请重试"
    invite_12: str = "⚠️无效的URL"
    invite_13: str = "❌任务已取消\n\n原因: 接收订阅链接超时"
    invite_14: str = "✨提交成功，请返回群组查看测试结果"
    invite_15: str = "❌此订阅已被加入到测试黑名单"
    match_cache: str = "订阅缓存已被命中，将不会从订阅地址重新获取订阅。"
    subinfo1: str = "❌此订阅无法获取流量信息~"
    subinfo2: str = "使用方法: /traffic & /subinfo & /流量查询 <订阅链接>"
    subinfo3: str = "正在查询流量信息..."
    subinfo4: str = "剩余("
    subinfo5: str = "天)"
    subinfo6: str = "⬆️已用上行："
    subinfo7: str = "⬇️已用下行："
    subinfo8: str = "🚗总共使用："
    subinfo9: str = "⏳剩余流量："
    subinfo10: str = "💧总流量："
    subinfo11: str = "⏱️过期时间："
    subinfo12: str = "🔍查询时间："
    subinfo13: str = "☁️订阅名称："
    subinfo14: str = "☁️订阅链接："
    subinfo15: str = "️✈️机场名："
    rule1: str = "规则已被命中： "
    rule2: str = "获取到的URL： "
    rule3: str = "❌你没有权限应用此规则"
    help_rule: str = "使用方法: /rule <订阅链接> <订阅名:可选>"
    rule4: str = "✅规则设置成功："
    rule5: str = "✅规则覆盖成功："
    rule6: str = "❌规则创建失败："
    rule7: str = "当前已保存的规则如下： \n\n"
    rule8: str = "❌没有找到保存的规则"
    rule9: str = "❌此规则名已被占用"
    rule10: str = "✅成功移除以下规则: "
    rule11: str = "❌以下规则移除失败，无法找到或者权限不够: "
    rule12: str = "使用方法: /remove <规则名1> <规则名2> ..."
    rule13: str = "已隐藏"
    init1: str = "初始化订阅黑名单(URL)成功，前往此地址查看："
    init2: str = "初始化订阅黑名单出错"
    init3: str = "初始化订阅黑名单(域名)成功，前往此地址查看："
    error_8: str = "❌非法参数，请检查!"
    log_1: str = "已输出日志文件的最后"
    log_2: str = "行"
    bypass: str = "旁路模式已启用，bot所有内置指令已被禁用，仅可以使用配置中的自定义指令~"
    setcmd: str = "正在设置自定义指令..."
    setcmd2: str = "成功设置自定义指令到TG(不代表已启用的bot指令): "
    setcmd3: str = "命令未在配置文件中启用，已被禁用，请在配置文件中启用或者关闭旁路模式后再试。"
    rule14: str = "🎨存在以下预设规则，选择可能会被覆盖：\n"
    realtime: str = "❌实时渲染"
    realtime2: str = "✅实时渲染"
    realtime3: str = "❌没有权限执行此操作"
    realtime4: str = "❌不支持节点数量大于40的实时渲染"
    realtime5: str = "⚠️图片大小已不适合实时渲染，太宽或者太长"


if __name__ == "__main__":
    t = Translation()
    with open("../../resources/i18n/zh-CN.yml", 'wb') as fp:
        t.to_yaml(fp, retain_raw=False)
        print("默认语言包文件已更新")
